/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "avrdebug.h"

#include <iostream>

void avrdebug::setErr(std::string errstring)
{
  if (isOK())
  {
    firstErr = errstring;
  }
  fOK = false;
}

void avrdebug::setOK()
{
  fOK = true; 
};

std::string avrdebug::getErr()
{
  if (isOK())
    return("");
  else
  {
    if (firstErr.length() == 0)
      return("error not specified");
    else
      return(firstErr);
  }
}

bool avrdebug::isOK()
{
  return(fOK);
}

bool avrdebug::addCmd(DebugCmd cmd)
{
  if (cmdblock.size())
    return(false);
  else
  {
    cmdblock.push_back(cmd);
    fExecuted = false;    
    return(true);
  }
}

void avrdebug::executeCmdBlock(ResultBlock& results)
{
  int size = cmdblock.size();
  
  for (int n=0; n<size; n++)
  {
    // std::cout << cmdblock[n].describe() << "\n";
    executeCmd(cmdblock[n], results);
  }
  
  fExecuted = true;
}

void avrdebug::clearCmdBlock()
{
  cmdblock.clear();
  
  fExecuted = true;
}

