/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef AVRDEBUG_PAR_H
#define AVRDEBUG_PAR_H

#include "avrdebug.h"

/**
 * Klasse, die eine Debugschnittstelle zu einem Controller bereitstellt.
 * 
 * Implementierung der Kommunikation über den Programmieradapter wie beim sp12 beschrieben, 
 * zusätzlich wird /SS des AVR mit Pin 17 (Control 3) verbunden.
 * 
 * Die Speicheradresse ist auf 15 Bit begrenzt.
 */
class avrdebug_par : public avrdebug
{
  public:
   avrdebug_par(int nAdr);
   ~avrdebug_par();

   void executeCmd(DebugCmd cmd, ResultBlock& results);
   
   int  resetTarget();

   int  connect();
      
  private:
   unsigned char uchDataState;
   int           uLPTPort;
   
   
   void selectSlave();
   void deselectSlave();
   void dataExchange(unsigned char  uchToSend,
                     unsigned char& uchRec);   
   bool testCom();   
};

#endif
