/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "debugcmd.h"

#include "lib_conversions.h"

void DebugCmd::setWriteBlock(unsigned int uAddrStart, unsigned int uSize, int nData)
{
  this->fWrite = true;
  this->uAddr  = uAddrStart;
  this->uSize  = uSize;
  this->nVal   = nData;
}

void DebugCmd::setReadBlock(unsigned int uAddrStart, unsigned int uSize)
{
  this->fWrite = false;
  this->uAddr  = uAddrStart;
  this->uSize  = uSize;
}

bool DebugCmd::write()
{
  return(fWrite);
}

unsigned int DebugCmd::addr()
{
  return(uAddr);
}

unsigned int DebugCmd::size()
{
  return(uSize);
}

int DebugCmd::value()
{
  return(nVal);
}

bool DebugCmd::combine(DebugCmd* item)
{
  if (item->write() != fWrite)
    return(false);
  
  if (fWrite && nVal != item->value())
    return(false);
  
  if (item->addr() == uAddr+uSize)
  {
    uSize += item->size();
    return(true);
  }
  
  return(false);
}

std::string DebugCmd::describe()
{
  std::string tmp = "";
  
  if (fWrite)
    tmp = "write ";
  else
    tmp = "read  ";

  tmp += itoStr(uSize, ' ', 1) + " bytes from addr " + itoStr(uAddr, ' ' , 1);
  if (fWrite)
    tmp += " value: " + itoStr(nVal, ' ', 1);
  
  return(tmp);
}

void DebugCmd::setSize(unsigned int uNewSize)
{
  uSize = uNewSize;
}

void DebugCmd::setAddr(unsigned int uNewAddr)
{
  uAddr = uNewAddr;
}



