/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef DEBUGCMD_H
#define DEBUGCMD_H

#include <string>

class DebugCmd
{
  public:
   
   /**
    * Returns nSize bytes read starting at address nAddrStart
    * before writing nData to the same adresses.
    */
   void setWriteBlock(unsigned int uAddrToWrite, unsigned int uSize, int nData);
   
   /**
    * Returns nSize bytes read starting at address nAddrStart.
    */
   void setReadBlock(unsigned int uAddrStart, unsigned int uSize);

   /**
    * write command?
    */
   bool write();
   
   /**
    * which (start) address to use?
    */
   unsigned int addr();
   
   /**
    * how many bytes?
    */
   unsigned int size();
   
   /**
    * which value to write?
    */
   int value();
   
   /**
    * Tries to merge the command item with this one. Returns true
    * on success.
    */
   bool combine(DebugCmd* item);
   
   std::string describe();

   void setSize(unsigned int uNewSize);
   void setAddr(unsigned int uNewAddr);
   
  private:

   bool          fWrite;
   unsigned int  uAddr;
   unsigned int  uSize;
   int           nVal;
};

#endif
