// -*- mode: c; mode: fold -*-

/*
 * Copyright (C) 2007  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef _HIRESTIME_H
#define _HIRESTIME_H


#include <sys/time.h>
#include <time.h>


class HiResTime
{
public:
   
  void Capture();
  
  /**
   * Mikrosekunden seit Capture
   */
  int GetUSecSinceCapture();
  
  /**
   * Millisekunden seit Capture
   */
  int GetMSecSinceCapture();
  
  void GetTimeSinceCapture(struct timeval* diff);
  
  /**
   * Berechnet (x - y)
   */
  static int GetUSecDiff(struct timeval* x, struct timeval* y);

  /**
   * Berechnet (x - y)
   */
  static int GetMSecDiff(struct timeval* x, struct timeval* y);

  /**
   * Berechnet (x - y)
   */
  static void GetTimeDiff(struct timeval* result, struct timeval* x, struct timeval* y);

  /**
   * Wartet mindestens time µs
   */
  static void sleep_us(int time_us);
  
private:
#ifndef WIN32
  struct timeval tv;
#endif
};



#endif
